% In development: automated report generation for Print for the mlSNLO functions
% (never got very far in this, it will be a lot of work to finish)
classdef mlSNLO_print < handle
    properties
        printfig
        % printfig        (1,1) struct = struct('fighandle', [], 'figwidth', 800, 'figheight', 1035, 'color', 'white', 'PaperUnits', 'normalized', 'PaperPosition', [0.05, 0.05, 0.90, 0.90]);
        numlines        (1,1) double {mustBeReal,mustBePositive}    = 2;
        numcols         (1,1) double {mustBeReal,mustBePositive}    = 3;
        label_fontname  string                                      = "Courier New";
        label_fontsize  (1,1) double {mustBeReal,mustBePositive}    = 9;
        data_fontname   string                                      = "Courier New";
        data_fontsize   (1,1) double {mustBeReal,mustBePositive}    = 9;
        figheight       (1,1) double {mustBeReal,mustBePositive}    = 1210;
        figwidth        (1,1) double {mustBeReal,mustBePositive}    = 935;
        figtag          (1,1) string    = "theprintfig";
        offscreen       (1,1) logical   = false;
        plothandles                                                 = [];
    end
    properties (Constant)
        screensize (1,4) double = get(groot, 'ScreenSize');
    end
    methods
        % function o = mlSNLO_print(varargin)
        function o = mlSNLO_print(namedArgs)
            arguments
                namedArgs.printfig          = [];
                namedArgs.numlines          = [];
                namedArgs.numcols           = [];
                namedArgs.label_fontname    = [];
                namedArgs.label_fontsize    = [];
                namedArgs.data_fontname     = [];
                namedArgs.data_fontsize     = [];
                namedArgs.plothandles       = [];
                namedArgs.figheight         = [];
                namedArgs.figwidth          = [];
            end
            % Constructor method
            % keyboard;
            props = ["printfig", "numlines", "numcols", "label_fontname", "label_fontsize", ...
                "data_fontname", "data_fontsize", "plothandles", "figheight", "figwidth"];
            for K = 1:length(props)
                if ~isempty(namedArgs.(props(K)))
                    try 
                        o.(props(K)) = namedArgs.(props(K));
                    catch E
                        keyboard;
                    end
                end
            end
            % o.numlines = namedArgs.numlines;
            % o.numcols  = namedArgs.numcols;
            % o.numlines = namedArgs.numlines;
            % o.numlines = namedArgs.numlines;
            % o.numlines = namedArgs.numlines;
        end
        function f = find_or_make_printfig(obj, namedArgs)
            arguments
                obj mlSNLO_print
                namedArgs.figtag = [];
            end
            if ~isempty(namedArgs.figtag)
                thefigtag   = namedArgs.figtag;
                obj.figtag  = thefigtag;
            else
                thefigtag   = obj.figtag;
            end

            f = findobj( 'tag', thefigtag );
            if isempty(f)
                x0 = 5;
                if obj.offscreen
                    x0 = x0 + obj.screensize(3);
                end
                f = figure( 'tag', thefigtag, ...
                    'Position', [x0, 5, obj.figwidth, obj.figheight], ...
                    'WindowStyle', 'normal', ...
                    'color', 'white', ...
                    'Renderer', 'painters');
            else
                if length(f) > 1
                    for K = 2:length(f)
                        if ishandle(f(K))
                            close(f(K));
                        end
                    end
                    f = f(1);
                end
            end
            set(f, 'units', 'pixels');
            obj.printfig = f;
        end
        function o = add_text_line(obj, namedArgs)
            % Add a new row of data values, with label, to print figure
            arguments
                obj mlSNLO_print
                namedArgs.position = [15, 50, 500, 25];
            end
            keyboard;
        end
        function o = add_label(obj, namedArgs)
            arguments 
                obj                 % 
                namedArgs.position  = [];
                namedArgs.parent    = obj.printfig;
            end
            keyboard;
        end
        function o = add_text_data(varargin)
            keyboard;
        end
        function o = add_plot(obj, plotHandles)
            arguments
                obj;
                plotHandles;
            end
            if isempty(plotHandles)
                keyboard;
                % return
            end
            for K = 1:length(plotHandles)
                if ishandle(plotHandles(K))
                    obj.plothandles(K) = copyobj(plotHandles(K), obj.printfig);
                end
            end
            keyboard;
        end
        function printIt(obj)
            keyboard;
            try
                printpreview(obj.printfig);
            catch E
                keyboard;
            end
        end
    end
end