classdef ristra12_gui < dynamicprops
    properties
        ristra12_edit_output_handle         (1,1)
        ristra_12_fig_outerheight           (1,1) double = 810;
        ristra_12_fig_outerwidth            (1,1) double = 460;
        ristra_12_run_window_outerheight    (1,1) double = 475;
        ristra_12_run_window_outerwidth     (1,1) double = 475;
        ristra_12_outputFigWidth            (1,1) double = 850
        ristra_12_outputFigHeight           (1,1) double = 650;
        screensize                          (4,1) double = [1, 1, 1920, 1080];
        fontName                            (1,1) string = "Arial";
        fontSize                            (1,1) double {mustBeFinite, mustBePositive, mustBeReal} = 8;
        monospacedFontName                  (1,1) string = "Courier New";
        monospacedFontSize                  (1,1) double {mustBeFinite, mustBePositive, mustBeReal} = 8;
        print_figure_offscreen              (1,1) logical = true;
        debugging                           (1,1) logical = true;
        input_filename                      (1,1) string = "r12_inputfile.mat";
        normalWindowColor                   (3,1) double = 0.94*[1,1,1];
        figname                             (1,1) string = "RISTRA 1 or 2 crystals"; % Used in window titlebar
        position                            (4,1) double = zeros(4,1);
        ristra_12_progressbar_handle        = [];
    end
    properties (Constant)
        figtag = 'ristra_12';
    end
    methods
        function o = ristra12_gui(varargin)
            o.screensize    = get(groot, 'ScreenSize');
            if ~verLessThan('matlab','9.0')
                o.ristra_12_fig_outerheight       = o.ristra_12_fig_outerheight+15;
                o.ristra_12_fig_outerwidth        = o.ristra_12_fig_outerwidth+10;
                o.ristra_12_run_window_outerheight= o.ristra_12_run_window_outerheight+15;
                o.ristra_12_run_window_outerwidth = o.ristra_12_run_window_outerwidth+10;
            end
            x = (o.screensize(3) - o.ristra_12_fig_outerwidth) / 2;
            y = (o.screensize(4) - o.ristra_12_fig_outerheight) / 2;
            o.position      = [x, y, o.ristra_12_fig_outerwidth, o.ristra_12_fig_outerheight];
            if ismac
                o.fontName = "Verdana";
                o.fontSize = 11;
            end

            if nargout == 0
                clear('o');
            end
        end
    end
end

% TODO: difference between get(0,'MonitorPositions') and get(groot,'ScreenSize') ?
%  How do multiple monitors behave with this?