function varargout = ristra12_v1point4(mixsrc,mixevt,varargin) %#ok<*INUSD>
%  ristra12 is a 1 or 2 crystal ristra model, based upon the 2D-cav-LP model.
% There are two crystals in this model. It is a nonplanar cavity with 4 flat
% mirrors. The RISTRA cavity is designed with mirror angles such that the light
% circulated through the cavity is rotated by 90 degrees on each pass. The
% transverse grids must be identical to simplify symmetry; the image is rotated
% by 45 degrees after mirror M2, and another rotation of 45 degrees happens
% after mirror M1. The second crystal is assumed to be identical to the first
% except for crystal length.
%
% The refractive index of Red1 will be used in calculating the time step, which
% is 1 cavity roundtrip.
%
% This function optionally accepts input argument of class ristra12_inputs (see
% ristra12_inputs.m) or ristra12_input_fields (see ristra12_input_fields.m). The
% properties of the ristra12_inputs object are used to populate the GUI input
% boxes. More information about each property can be found in ristra12_inputs.m.
% 
% A description of the output variables of the ristra12 model can be found in
% Ristra12_output_variables.html
%
% Written by Jesse Smith (jesse.smith@as-photonics.com) based on APL model
% written by Arlee Smith (arlee.smith@as-photonics.com) Last updated November 7,
% 2024 - Version 1.4.
